#include <iostream>
#include <fstream>
#include <vector>
#include <map>
#include <set>
#include "X_from_operator.hpp"

//g++ mycxxprog.cc -lgmpxx -lgmp

using namespace std;

mpq_class readRat(){//Reads the rational growth rate
  cout<<" What should the growth rate be ?"<<endl; 
  cout<<" Give a rational number: enter the numerator and the denominator separated by a blank space."<<endl; 
  mpz_class n,d; cin >>n>>d;  
  return mpq_class(n)/d;
}

Number readAlg(){//Reads the algrebraic growth rate
  cout<<"   What should the growth rate be ?"<<endl; 
  cout<<"   Give an irrational algrebraic real number. First give a rational multiple of the minimal polynomial (of degree at least 2) with integer coeficients."<<endl; 
  cout<<"   For that enter pairs of integers i j such that the coefficient of x^i is j. You need to start with the term of highest degree and to end with the pair 0 j (where j is the constant term of the polynomial). Every unspecified term is set to 0."<<endl;
  cout<<"   Finaly give a pair of rational numbers (each given as a pair of integers separated by a blank space) around the root that uniquely determines it."<<endl;
  cout<<"   For instance for any number of the form a^(1/b) (with a and b positive integers) one could chose the polynomial x^b-a and the interval [1,2] and write: b 1 0 -a 1 1 2 1. "<<endl; 
  int a, c, d, e; mpq_class b; 
  cin>>a>>b;
  vector<mpq_class> p(a+1,0);
  p[a]=b;
  while(true){
    cin>>a>>b;
    p[a]=b;
    if(a == 0) break;
  }
  cin >> a>>c>>d>>e;
  pair<mpq_class,mpq_class> approx(mpq_class(a)/c,mpq_class(d)/e);
  Number::setPoly(p, approx);
  Number::improveAp(500);
  Number coef(0);
  coef.val[1]=1;
  return coef;
}

class automaton_tree{// This class reads a tree-automaton produced by mona and provides some basics operations
public:
  size_t size_Mat;
  vector<int> baseVect;
  vector<vector<pair<int,int>>> transMat; 
  vector<int> evaluateVect;
  
  automaton_tree(){ }
  void readFromStream(ifstream & streamIn){// This function reads a tree automaton from the file produced by mona. A preprocessing done in the bash script is needed.
    set<int> acceptingset, tempAccepting;
    int read;
    streamIn>>read;
    while(read != -1){
      tempAccepting.insert(read);
      streamIn >> read;
    }

    streamIn >>read; streamIn>>read;
    map<int,int> rename;
    int renameSize=0;
    while(read != -1){
      int b, d; 
      string s;
      streamIn >> b >> s >> d;
      if(tempAccepting.find(d) != tempAccepting.end()){
        if(rename.find(read)==rename.end()) rename[read]=renameSize++;
        acceptingset.insert(rename[read]);
      }
      streamIn >> read;
    }

    int fakeInitial; 
    streamIn >> fakeInitial;
    streamIn >> read;
    while(read != -1){
      int b, d; 
      string s;
      streamIn >> b >> s >> d;
      if(b != fakeInitial && read != fakeInitial){
        if(rename.find(d) == rename.end()) rename[d] = renameSize++;
        if(rename.find(b) == rename.end()) rename[b] = renameSize++;
        if(rename.find(read) == rename.end()) rename[read] = renameSize++;
        if(transMat.size() <= rename.size()){ transMat.resize(rename.size()); baseVect.resize(rename.size());}
        transMat[rename[d]].push_back(pair<int,int>(rename[read], rename[b]));
        if(s == "X") transMat[rename[d]].push_back(pair<int,int>(rename[read], rename[b]));
      }else if(b == fakeInitial && read == fakeInitial){
        if(rename.find(d) == rename.end()) rename[d] = renameSize++;
        if(transMat.size() <= rename.size()){ transMat.resize(rename.size()); baseVect.resize(rename.size());}
        baseVect[rename[d]]+=(s == "X")?2:1;
      }
      streamIn>>read;
    }
    evaluateVect=vector<int>(baseVect.size(),0);
    for(auto it=acceptingset.begin(),ie=acceptingset.end(); it!=ie; it++)
      evaluateVect[*it]=1;
    size_Mat=baseVect.size();
  }
  
  void primitiveSuboperator(){//This function removes states that are not accessible and co-accessible
    if(baseVect.size()==0) return ;
    vector<bool> usefull(size_Mat, false);
    vector<bool> used(size_Mat, false);
    for(size_t i=0; i<size_Mat ; i++)
      if(evaluateVect[i] != 0) usefull[i]= true;
    for(size_t i=0; i<size_Mat ; i++)
      if(baseVect[i] != 0) used[i]=true;
    bool done = false;
    while(!done){
      done = true;
      for(size_t i=0; i<transMat.size(); i++){
        for(size_t j=0; j<transMat[i].size(); j++){
          if(usefull[i]){ 
            if(!(usefull[transMat[i][j].first] && usefull[transMat[i][j].second])) done = false;
            usefull[transMat[i][j].first] = usefull[transMat[i][j].second] = true;
          }
          if(used[transMat[i][j].first] && used[transMat[i][j].second]){
            if(!used[i]) done = false;
            used[i] = true;
          }
        }
      }
    }

    for(size_t i=0; i<size_Mat; i++)
      usefull[i] = usefull[i] && used[i];
    
    vector<int> mappedTo(usefull.size());
    size_Mat=0;
    for(size_t i=0; i<usefull.size(); i++){
      if(usefull[i]) mappedTo[i] = size_Mat++;
      else mappedTo[i]=-1;
    }
    
    vector<vector<pair<int,int>>>transtemp(size_Mat);
    for(size_t i=0; i<transMat.size();i++){
      if(!usefull[i]) continue;
      for(size_t j=0;j<transMat[i].size();j++){
        if(usefull[transMat[i][j].first] && usefull[transMat[i][j].second]) 
          transtemp[mappedTo[i]].push_back(pair<int,int>(mappedTo[transMat[i][j].first], mappedTo[transMat[i][j].second]));        
      }
    }
    transMat.swap(transtemp);
    
    vector<int> baseVecttemp(size_Mat);
    for(size_t i=0; i<baseVect.size();i++){
      if(!usefull[i]) continue;
      else baseVecttemp[mappedTo[i]]=baseVect[i];
    }
    baseVect.swap(baseVecttemp);
    
    vector<int> evaluateVecttemp(size_Mat);
    for(size_t i=0; i<evaluateVect.size();i++){
      if(!usefull[i]) continue;
      else evaluateVecttemp[mappedTo[i]]=evaluateVect[i];
    }
    evaluateVect.swap(evaluateVecttemp);
  } 
    
  void print(){// This function prints the bilinear operator
    cout<<"The minimal accessible and co-accessible bilinear operator is given by"<<endl;
    for(size_t i=0; i<transMat.size(); i++){
//       cout<< "  w_"<<i+1<<"=";
      if(transMat[i].size()==0) cout<<"0";
      for(size_t j=0;j<transMat[i].size();j++)
        cout<<((j == 0)? ' ':'+')  <<" u_{"<<transMat[i][j].first+1<<"}v_{"<<transMat[i][j].second+1<<"}";
      cout<<"\\\\"<<endl;
    }
    cout<<" The initial vector V_0 is:"<<endl;
    for(size_t i=0; i<baseVect.size(); i++) cout<<baseVect[i]<<"  ";
    cout<<endl<<" The final vector F is:"<<endl;
    for(size_t i=0; i<baseVect.size(); i++) cout<<evaluateVect[i]<<"  ";
    cout<< endl<<endl<<"************************************************"<<endl;

  }
};

template< class Qel>
Qel eval(vector<int>& Evec, vector<Qel>& v){
    Qel tot=0;
    if(Evec.size()!= v.size()) {cout<<"dafuq "<<Evec.size()<< "   "<< v.size()<<endl; exit(0);}
    for(size_t i=0; i<v.size(); i++)
      if(Evec[i]==1) tot += v[i];
    return tot;
}

int main(int argc, char **argv){
  // We start by reading and cleaning the tree automaton.
  automaton_tree T;
  ifstream ifTemp(argv[1]);
  T.readFromStream(ifTemp);
  T.primitiveSuboperator();
  T.print();
  //Then we reads the growth rate and calls the main programm. We now read from the standart input.
  cout<<"Is the growth rate rational or algebraic non-rational ? (Type 0 for rational and 1 for algebraic non rational)"<<endl;   
  int algOrRate; cin >> algOrRate;
  if(algOrRate == 0){
    mpq_class coef = readRat();
    vector<vector<mpq_class>> sep(1,vector<mpq_class>(T.baseVect.size()));
    for (size_t i=0; i<T.baseVect.size(); i++) sep[0][i]=T.baseVect[i]/coef;
    while(true){
      cout<<"Do ou whish to add a vector to the set X at the start ? (This is usefull for instance for proposition 32.) If yes enter 1 and else -1."<<endl;
      int a;
      cin>>a;
      if(a == -1) break;
      cout<<"Enter the "<< T.baseVect.size()<<" entries of the vector separated by a blank space."<<endl;
      vector<mpq_class> v(T.baseVect.size(),0);
      for(size_t i=0; i<v.size(); i++) cin>>v[i];
      sep.push_back(v);
    }
    
    vector<vector<vector<pair<int,int>>>> op(1,T.transMat);   
    findX(op, sep, coef);
  }else{
    Number coef = readAlg();
    vector<vector<Number>> sep(1,vector<Number>(T.baseVect.size()));
    for (size_t i=0; i<T.baseVect.size(); i++) sep[0][i]=T.baseVect[i]/coef;
    while(true){
      cout<<"Do ou whish to add a vector to the set X at the start ? (This is usefull for instance for proposition 32.) If yes enter 1 and else -1."<<endl;
      int a;
      cin>>a;
      if(a == -1) break;
      cout<<"If yes enter 1 and the "<< T.baseVect.size()<<" entries of the vector separated by a blank space."<<endl;
      cout<<"For each coordinate of the vector give the "<< Number::deg <<" coefficients of the polynomial in the growth rate from lowest to highest degree."<<endl;
      vector<Number> v(T.baseVect.size(),0);
      for(size_t i=0; i<v.size(); i++) cin>>v[i];
      sep.push_back(v);
    }

    vector<vector<vector<pair<int,int>>>> op(1,T.transMat);   
    findX(op, sep, coef);
    
    Number C = sep[0][0];
    for(size_t i=0; i<sep.size(); i++)
      if(eval(T.evaluateVect, sep[i])>C) C = eval(T.evaluateVect, sep[i]);
    cout<<" C is "<<C<<endl;
  }
  return 0;
}
